/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "includes.h"

/**
	This function is supposed to initiate the entire HAED_GLOBAL_TRIGGER_GRID.
*/
void haed_triggers_visual_init(void)
{
	//Define the box for the conditionswindow
	MAIN_ConditionsBox=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,1);
	g_object_ref(MAIN_ConditionsBox);
	//define for select object window
	MAIN_GetObjBox=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,1);
	g_object_ref(MAIN_GetObjBox);

	HAED_GLOBAL_TRIGGER_GRID=gtk_grid_new();
					
		MAIN_LeftTopInfo=gtk_label_new("All the events");
		gtk_grid_attach(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),MAIN_LeftTopInfo,1,1,2,1);

		listFunctions[0]=gtk_button_new();
			g_signal_connect(listFunctions[0], "clicked",G_CALLBACK (NewCondition), 0);
			gtk_button_set_label(GTK_BUTTON(listFunctions[0]),"1");
		gtk_grid_attach(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),listFunctions[0],1,2,1,1);

		listFunctions[1]=gtk_label_new("⚫ New condition");
		gtk_grid_attach(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),listFunctions[1],2,2,1,1);
	gtk_box_pack_start(GTK_BOX(HAED_GLOBAL_TRIGGER_BOX),HAED_GLOBAL_TRIGGER_GRID,0,0,0);

	haed_object_add_trigger_std((char*)TRIGGERS_SPECIAL_S,NULL,TRIGGERS_SPECIAL_S);
	b_tm("ADDED ONE");
	haed_object_add_trigger_std((char*)TRIGGERS_SOUND_S,NULL,TRIGGERS_SOUND_S);
	haed_object_add_trigger_std((char*)TRIGGERS_STORY_S,NULL,TRIGGERS_STORY_S);
	haed_object_add_trigger_std((char*)TRIGGERS_INPUT_S,NULL,TRIGGERS_INPUT_S);
}

void haed_triggers_visual_destroy(void)
{
	//Define the box for the conditionswindow
	if(MAIN_ConditionsBox)
		gtk_widget_destroy(MAIN_ConditionsBox);
	
	if(MAIN_GetObjBox)
		gtk_widget_destroy(MAIN_GetObjBox);

	if(HAED_GLOBAL_TRIGGER_GRID)
		gtk_widget_destroy(HAED_GLOBAL_TRIGGER_GRID);
	//maybe something more?
}

/**
	Needs to be run before the eksparent is read
*/
void haed_triggers_visual_reset(void)
{
	haed_trigghandler_clean();
	b_tm("free ok");
	haed_triggers_visual_destroy();
	b_tm("visual destroy ok");
	
	HAED_GLOBAL_TRIGGER_HANDLER=calloc(1,sizeof(TriggerHandler));
	
	haed_triggers_visual_init();
	b_tm("add objects to triggers");
	
	//b_tm("visual init ok");
	//haed_eks_set_triggers_from_parent(program);
	
	gtk_widget_show_all(HAED_GLOBAL_TRIGGER_GRID);
}

void haed_triggers_remove_condition_press(GtkWidget *widget, gpointer data)
{
	//GtkWidget *tempWidget=HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton;
	//EksParent *tempObject=g_object_get_data(G_OBJECT(HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton),"haed_object");
	
	//EksParent *tempCondition=g_object_get_data(G_OBJECT(HAED_GLOBAL_INFORMATION.triggerEditorCurrentButton),"haed_condition");
	UITriggRow *thisRow=data;
	
	EksParent *tempCondition=thisRow->toConditionLinker;

	printf("%s\n",tempCondition->name);

	printf("%s\n",eks_parent_dump_text(tempCondition));

	haed_trigghandler_remove_condition(HAED_GLOBAL_TRIGGER_GRID,tempCondition);
}

/**
	When the user clicks on the num button, close to the condition

	@param widget NO_FREE
		the button widget
	@param event NO_FREE
		in event
	@param data
	@return 
		void

	@param globals MAIN_ActiveObjectMenu MAIN_ActiveObjectMenuList
*/
void haed_triggers_insert_button_press(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	if(MAIN_ActiveObjectMenu!=NULL)
	{
		gtk_widget_destroy(MAIN_ActiveObjectMenu);
		MAIN_ActiveObjectMenu=NULL;
	}

	//general stuff
	GtkMenuListInner MAIN_ActiveObjectMenuList[]=
	{
		{"Insert",NULL,NULL},
		{"Remove",haed_triggers_remove_condition_press,data}
	};

	MAIN_ActiveObjectMenu=gtk_menu_new_from_list(MAIN_ActiveObjectMenuList,sizeof(MAIN_ActiveObjectMenuList)/sizeof(MAIN_ActiveObjectMenuList[0]));
	gtk_widget_show_all(MAIN_ActiveObjectMenu);

	CreatePopupMenu(MAIN_ActiveObjectMenu,event);
}

/**
	Insert the condition into the graphical layout.

	@param handler INNER_REALLOC
		the handler for the trigger settings ( the one you see in trigger editor )
	@param triggerGrid NO_FREE
		the grid to insert it into
		- REMOVE? this should be integrated so it will be drawn into it with another function.
	@param conditionIn
		A bottom level parent containing the condition.
	@return
		void
*/
void haed_triggers_insert_row(GtkWidget *triggerGrid,EksParent *conditionIn)
{
	TriggerHandler *handler=HAED_GLOBAL_TRIGGER_HANDLER;

	int currentRow;
	UITriggRow *thisRow;
	
	handler->rowAmount++;
	
	gtk_grid_insert_row(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),handler->rowAmount+1);
	
	handler->row=realloc(handler->row,sizeof(UITriggRow*)*(handler->rowAmount));
	
	currentRow=handler->rowAmount-1;
	
	handler->row[currentRow]=calloc(1,sizeof(UITriggRow));
	thisRow=handler->row[currentRow];
	
	//STANDARD DEFINITIONS FOR ROW
	//thisRow->number=currentRow;
	thisRow->toConditionLinker=conditionIn;
	
	
	thisRow->ActionButtons=malloc(sizeof(GtkWidget*)*(handler->columnAmount));
	
	thisRow->conditionInf=gtk_label_new(concat("⚫ ",conditionIn->name,NULL));
	//gtk_label_set_justify(GTK_LABEL(thisRow->conditionInf), GTK_JUSTIFY_LEFT);
	gtk_grid_attach(GTK_GRID(triggerGrid),thisRow->conditionInf,2,2+currentRow,1,1);
	gtk_widget_show(thisRow->conditionInf);
	
	thisRow->numberInf=gtk_button_new_with_label(b_int_to_string(handler->rowAmount));
	gtk_grid_attach(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),thisRow->numberInf,1,2+currentRow,1,1);
	//void i = send custom
	g_signal_connect(thisRow->numberInf, "button_press_event",G_CALLBACK(haed_triggers_insert_button_press),thisRow);
	gtk_widget_show(thisRow->numberInf);
	
	b_tm("columnAmount: %d",handler->columnAmount);	
	
	for(int i=0;i<handler->columnAmount;i++)
	{
		thisRow->ActionButtons[i]=gtk_button_new_with_label(" ");
		gtk_grid_attach(GTK_GRID(HAED_GLOBAL_TRIGGER_GRID),thisRow->ActionButtons[i],3+i,2+currentRow,1,1);
		gtk_widget_show(thisRow->ActionButtons[i]);
		
		//4=engine units
		if(handler->objects[i])
			haed_triggers_bind_object_to_button(thisRow->ActionButtons[i],conditionIn,handler->objects[i]);
	}
	
	gtk_button_set_label(GTK_BUTTON(listFunctions[0]),b_int_to_string(handler->rowAmount+1));
}

/*
=============================GRAPHICAL===========================
*/
//3 HANDLE FUINCTIONS

/**
	Adds a condition to a trigger-based parent structure

	@param level .
		level to add it to. 0=1 map (will use eks_parent_get_child)
	@param conditionString NO_FREE
		the conditionString
	@return
		the pointer to the EksParent to the trigger. (not the top-level one)

	@param globals GLOBAL_TRIGGER_PARENT
*/
EksParent *haed_triggerparent_add_condition(int level, char *conditionString)
{
	EksParent *theTrigger=NULL;
	
	theTrigger=eks_parent_add_child(GLOBAL_TRIGGER_PARENT,conditionString,EKS_PARENT_TYPE_VALUE,NULL);

	b_tm("%s",eks_parent_dump_text(GLOBAL_TRIGGER_PARENT));

	return theTrigger;
}

//==============ACTIONS===============
/**
	Will just add the actionString into the global trigger parent
*/
char *haed_triggerparent_add_action(EksParent *conditionEksParent,char *actionString)
{
	if(conditionEksParent==NULL)
	{
		b_error_message("ERROR ON ADDING ACTION!");
		return NULL;
	}
	else
	{
		printf("Number of children: %ld Upper parent: %s\n",eks_parent_get_child_amount(conditionEksParent),conditionEksParent->upperEksParent->name);
		//if it exists
		for(int i=0;i<eks_parent_get_child_amount(conditionEksParent);i++)
		{
			EksParent *child=eks_parent_get_child(conditionEksParent,i);
		
			if(eks_parent_compare_type(child,EKS_PARENT_TYPE_VALUE) && strcmp(actionString,child->name)==0)
				return 0;
		}
		
		printf("ERRR!\n");
		
		EksParent *theTrigger=eks_parent_add_child(conditionEksParent,actionString,EKS_PARENT_TYPE_VALUE,NULL);
		
		return theTrigger->name;
	}
}

/**
	Add cross to button, and add info text about it.

	@param widget
		button
	@param actionText
		text to add to it
*/
void haed_triggers_add_visual_for_action(GtkWidget *widget,char *actionText)
{
	//get hover string
	char *buttonActionList=gtk_widget_get_tooltip_text(widget);
	
	//set as action set
	gtk_button_set_label(GTK_BUTTON(widget),"X");
	
	//update hover string
	if(buttonActionList==NULL)
	{
		buttonActionList=g_strndup(actionText,strlen(actionText));
	}
	else
	{
		buttonActionList=concat(buttonActionList,"\n",actionText,NULL);
	}
	
	gtk_widget_set_tooltip_text(widget,buttonActionList);
}

void haed_triggers_create_popup_from_menu_list(GtkMenuListInner *theList,size_t listSize,GdkEvent *event)
{
	MAIN_ActiveObjectMenuTriggers[0]=gtk_menu_new_from_list(theList,listSize);
	gtk_widget_show_all(MAIN_ActiveObjectMenuTriggers[0]);
	
	//show the menu
	CreatePopupMenu(MAIN_ActiveObjectMenuTriggers[0],event);
}
